
#if __EDG_VERSION__ < 300

typedef void *		__builtin_va_list;
#define 		__builtin_stdarg_start(ap,param)
#define 		__builtin_next_arg(p) 0
#define 		__builtin_va_arg(ap,type) 0
#define 		__builtin_va_end(ap)

extern void *		__builtin_alloca(unsigned int);
extern int 		__builtin_ffs(int);
extern int 		__builtin_abs(int);
extern float 		__builtin_fabsf(float);
extern double 		__builtin_fabs(double);
extern long double 	__builtin_fabsl(long double);
extern long int 	__builtin_labs(long int);
extern void *		__builtin_memcpy(void *, const void *, unsigned int);
extern int	 	__builtin_memcmp(const void *, const void *, unsigned int);
extern int 		__builtin_strcmp(const char *, const char *);
extern char *		__builtin_strcpy(char *, const char *);
extern unsigned int 	__builtin_strlen(const char *);
extern double 		__builtin_sqrt(double);
extern float 		__builtin_sqrtf(float);
extern long double 	__builtin_sqrtl(long double);
extern double 		__builtin_sin(double);
extern float 		__builtin_sinf(float);
extern long double 	__builtin_sinl(long double);
extern double 		__builtin_cos(double);
extern float 		__builtin_cosf(float);
extern long double 	__builtin_cosl(long double);
extern char *		__builtin_strchr(const char *, int);
extern char *		__builtin_strrchr(const char *, int);
extern char *		__builtin_strpbrk(const char *, const char*);
extern char *		__builtin_strstr(const char *, const char *);

#define 		__builtin_return(result) return(result)
#define			__builtin_constant_p(X) 0
extern void *		__builtin_apply_args (void);
extern void *		__builtin_apply (void (*)(), void *, int);
extern int 		__builtin_return_address (int);
extern int 		__builtin_frame_address (int);

#define 		__builtin_isgreater(x, y) 0
#define 		__builtin_isgreaterequal(x, y) 0
#define 		__builtin_isless(x, y) 0
#define 		__builtin_islessequal(x, y) 0
#define 		__builtin_islessgreater(x, y) 0
#define 		__builtin_isunordered(x, y) 0
#define 		__builtin_classify_type(x, y) 0
#define 		__builtin_expect(x, y) 0
#endif

#if __EDG_VERSION__ <= 309
extern int __sync_fetch_and_add(volatile int* __mem, int __val);
extern int __sync_fetch_and_sub(volatile int* __mem, int __val);
extern int __sync_fetch_and_or(volatile int* __mem, int __val);
extern int __sync_fetch_and_and(volatile int* __mem, int __val);
extern int __sync_fetch_and_xor(volatile int* __mem, int __val);
extern int __sync_fetch_and_nand(volatile int* __mem, int __val);

// Only for GCC 4.3.0 and above
#if __GNUC__ > 4 || (__GNUC__ == 4 && (__GNUC_MINOR__ >= 3 ))

#define __has_nothrow_assign sizeof
#define __has_nothrow_copy sizeof
#define __has_nothrow_constructor sizeof
#define __has_trivial_assign sizeof
#define __has_trivial_copy  sizeof
#define __has_trivial_constructor sizeof
#define __has_trivial_destructor sizeof
#define __has_virtual_destructor sizeof
#define __is_abstract sizeof
#define __is_class sizeof
#define __is_empty sizeof
#define __is_enum sizeof
#define __is_pod sizeof
#define __is_polymorphic sizeof
#define __is_union sizeof
#define __is_trivial(T) 0
#define __decltype(v) int
#define __atomic_fetch_add(m,v,l) *m

#define __builtin_bswap32(x) x

void* __builtin_memchr(const  void * ptr, int value, unsigned long long num);
#endif
#endif /* __EDG_VERSION__  */
